#include "tamtypes.h"
#include "sifrpc.h"
#include "sifcmd.h"

#include "iopheap.h"

static struct t_SifRpcClientData _ihcd __attribute__((aligned(16)));
static int _ih_initialized = 0;
// sifLoadModule rpc call var's
static char _senddata[512] __attribute__((aligned(16)));
static char _recvdata[512] __attribute__((aligned(16)));


int _SifInitIopHeap()
{
    if(_ih_initialized) {
        return 0;
    }

    memset(&_ihcd, 0, sizeof(_ihcd));

    if (SifBindRpc(&_ihcd, 0x80000003, 0) < 0) {
        return -1;
    }

    if(_ihcd.server == NULL) {
        return -1;
    }

    _ih_initialized = 1;

    return 0;
}


void *_SifAllocIopHeap(int size)
{
    if (!_ih_initialized)
        return 0;

    *(unsigned int *)(&_senddata[128]) = size;

    if (SifCallRpc(&_ihcd, 1, 0, &_senddata[128], 4, &_recvdata[0], 4, 0, 0) < 0) {
        return 0;
    }

    return (void *)(*(unsigned int *)(&_recvdata[0]));
}


int _SifFreeIopHeap(void *addr)
{
    if (!_ih_initialized)
        return 0;

    *(int *)(&_senddata[128]) = (int)addr;

    if (SifCallRpc(&_ihcd, 2, 0, &_senddata[128], 4, &_recvdata[0], 4, 0, 0) < 0) {
        return 0;
    }

    return *(int *)(&_recvdata[0]);
}

/*****  load iop heap is giving errors it seems *****/

int _SifLoadIopHeap(char *fname, void *addr)
{
    int i;

    if (!_ih_initialized)
        return 0;

    if (fname[0] = '\0')
        return 0;

    for (i=0; i<252; i++)
    {
        _senddata[4+i] = fname[i];
        if (fname[i] == '\0')
            break;
    }
    _senddata[255] = 0;
    *(int *)(&_senddata[0]) = (int)addr;

    if (SifCallRpc(&_ihcd, 3, 0, &_senddata[0], 256, &_recvdata[0], 4, 0, 0) < 0) {
        return 0;
    }

    return *(int *)(&_recvdata[0]);
}





